import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Link, LinkParam } from './model';

/**
 * JSON数据
 */
export async function getLinkType() {
  return {
    list: [
      { value: '0', label: '应用组件', text: '应用组件', comments: '' },
      { value: '1', label: '外部链接', text: '外部链接', comments: '' }
    ]
  };
}

/**
 * 分页查询链接
 */
export async function pageLink(params: LinkParam) {
  const res = await request.get<ApiResult<PageResult<Link>>>('/oa/link/page', {
    params
  });
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询链接列表
 */
export async function listLink(params?: LinkParam) {
  const res = await request.get<ApiResult<Link[]>>('/oa/link', {
    params
  });
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加链接
 */
export async function addLink(data: Link) {
  const res = await request.post<ApiResult<unknown>>('/oa/link', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改链接
 */
export async function updateLink(data: Link) {
  const res = await request.put<ApiResult<unknown>>('/oa/link', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除链接
 */
export async function removeLink(id?: number) {
  const res = await request.delete<ApiResult<unknown>>('/oa/link/' + id);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除链接
 */
export async function removeBatchLink(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>('/oa/link/batch', {
    data
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>('/oa/link/existence', {
    params: { field, value, id }
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
